# -*- coding: utf-8 -*-
#
# Copyright (c) 2006 by Blue Dynamics Alliance Klein und Partner KEG Austria
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """Jens Klein <jens@bluedynamics.com>"""
__docformat__ = 'plaintext'

from zope.interface import Interface

class IParsedStatistics(Interface):
    """Marker interface to make ParsedStatistics adaptable."""

class IParsedMonth(Interface):
    """Marker interface to make ParsedMonth adaptable."""
    
class IParsedSection(Interface):
    """Marker interface to make ParsedSection adaptable."""    

class IAwstatsProvider(Interface):
    """Class providing an ParsedStatistics object on demand."""
    
    def getStatistics(domain):
        """returns the ParsedStatistics for given domain."""
        
    def reload(domain):
        """reload the statistics for given domain or reload all statistics
        if domain is None."""
    
    def statsAvailable():
        """Check if statistics are available."""
    
    def getAllowedDomains():
        """Return a list of domains."""
        
class IStatsView(Interface):
    """Interface definition for the statistics view class."""
    
    def initialize():
        """"""
    
    def statsAvailable():
        """"""
    
    def statsAllowed():
        """"""
    
    def domainSelected(domain):
        """"""
    
    def monthSelected(month):
        """"""
    
    def yearSelected(year):
        """"""
    
    def getGeneralLastModified():
        """"""
    
    def getAllowedDomains():
        """"""
    
    def getMonthSelection():
        """"""
        
    def getYearSelection():
        """"""
    
    def getSiteUrl():
        """"""
    
    def getEpoch():
        """"""
    
    def getFirstTime():
        """"""
        
    def getLastTime():
        """"""
    
    def getTotalUnique(my=None):
        """"""
    
    def getTotalVisits(my=None):
        """"""
    
    def getTotalAverage():
        """"""

    def getTotalKnownPages(my=None):
        """"""
    
    def getTotalPagesAverage():
        """"""
    
    def getTotalKnownHits(my=None):
        """"""
    
    def getTotalHitsAverage():
        """"""
    
    def getTotalKnownBytes(my=None):
        """"""
    
    def getTotalBytesAverage():
        """"""
    
    def getTotalUnknownPages():
        """"""
    
    def getTotalUnknownHits():
        """"""
    
    def getTotalUnknownBytes():
        """"""
    
    def getMonthGraph():
        """"""
    
    def getMonthBarNames():
        """"""
        
    def getMonthOverview():
        """"""
        
    def getMonthSum():
        """"""
    
    def getDaysInMonthGraph():
        """"""
    
    def getDaysInMonthBarNames():
        """"""
    
    def getDayInMonthOverview():
        """"""
    
    def getDayInMonthAverage():
        """"""
    
    def getDayInMonthSum():
        """"""
    
    def getWeekdaysGraph():
        """"""
    
    def getWeekdaysBarNames():
        """"""
    
    def getWeekdaysOverview():
        """"""
    
    def getServertimeGraph():
        """"""
    
    def getServertimeBarNames():
        """"""
    
    def getServertimeOverview():
        """"""
    
    def getCountryData():
        """"""
    
    def getCountryBarNames():
        """"""
    
    def getClientSummaryText():
        """"""
    
    def getClientSummary():
        """"""
        
    def getRobotSummary():
        """"""
    
    def getSessionSummary():
        """"""
        
    def getDatatypeSummary():
        """"""
    
    def getSiteUrlInfoText():
        """"""
    
    def getSiteUrlData():
        """"""
    
    def getSiteUrlBarNames():
        """"""
    
    def getOsSummary():
        """"""
    
    def getBrowserSummary():
        """"""